
#ifndef _UDP_H_
#define _UDP_H_
#include <inttypes.h>

#define UDP_ENABLE_DEBUG_INC

#define UDP_HEADER_SIZE   (2 + 2 + 2 + 2)

#define UDP_SRCPORT_OFS (IP_DATA_OFS + 0)
#define UDP_DSTPORT_OFS (IP_DATA_OFS + 2)
#define UDP_DATALEN_OFS (IP_DATA_OFS + 4)
#define UDP_CRC_OFS     (IP_DATA_OFS + 6)
#define UDP_DATA_OFS    (IP_DATA_OFS + 8)


//msfs:
#ifndef DWORD
	#define DWORD unsigned long
#endif //DWORD
#ifndef WORD
	#define WORD unsigned short
#endif //WORD

struct tag_DataExample
{
    DWORD dwHeaderVersion;//header vererion
    DWORD dwHeaderLen;//header length (bytes) & flags
    DWORD dwDeviceID;//device ID
    DWORD dwLiveTime;//LIVE time (ms)
    DWORD dwDataLength;//data length
};
typedef struct tag_DataExample DataExample;
typedef DataExample * PDataExample;

struct tag_MSFS_FSUIPC3_Data_Chunk
{
    WORD wAddress;//FSUIPC address
    WORD wSizeInBytes;//data size in bytes
    union tag_uData//data
    {
        int nData;//int
        //float fData;//float
        //double dData;//double
        unsigned char szData[8];//char array (8 bytes)
    }uData;
};

typedef struct tag_MSFS_FSUIPC3_Data_Chunk MSFS_FSUIPC3_Data_Chunk;
typedef MSFS_FSUIPC3_Data_Chunk * PMSFS_FSUIPC3_Data_Chunk;


unsigned short UDP_CRC16(unsigned short *pData, unsigned short nLen);
void SendUDP(unsigned short nPortSrc, //source port 
			 unsigned short nPortDst, //destination port
			 unsigned short *pData, //data
			 unsigned short nDataLength //data length (bytes)
			 );

void UDP_Init_MSFS_Array(void);
void UDP_SendHandler(void);

PDataExample UDP_GetRecvDataHeader(void);
PMSFS_FSUIPC3_Data_Chunk UDP_GetRecvDataChunk(void);
void UDP_InitReceiver(void);
void UDP_Reciever(void);

#ifdef UDP_ENABLE_DEBUG_INC
	void UDP_Debug_IncCounter(void);
#else //UDP_ENABLE_DEBUG_INC
	#define UDP_Debug_IncCounter()
#endif //UDP_ENABLE_DEBUG_INC

#endif //!_UDP_H_
